# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FLIRT_NEWDEFAULT_20080811_SCH_METADATA = Metadata(
    id="feb43e2c92a18f6dadfa470638890ab96bd75d9d.boutiques",
    name="flirt.newdefault.20080811.sch",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


FlirtNewdefault20080811SchParameters = typing.TypedDict('FlirtNewdefault20080811SchParameters', {
    "__STYX_TYPE__": typing.Literal["flirt.newdefault.20080811.sch"],
    "term_option": typing.NotRequired[str | None],
    "curses_flag": bool,
    "scrollback_flag": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "flirt.newdefault.20080811.sch": flirt_newdefault_20080811_sch_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class FlirtNewdefault20080811SchOutputs(typing.NamedTuple):
    """
    Output object returned when calling `flirt_newdefault_20080811_sch(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def flirt_newdefault_20080811_sch_params(
    term_option: str | None = None,
    curses_flag: bool = False,
    scrollback_flag: bool = False,
) -> FlirtNewdefault20080811SchParameters:
    """
    Build parameters.
    
    Args:
        term_option: Use this terminal type instead of $TERM.
        curses_flag: Print curses-version.
        scrollback_flag: Do not try to clear scrollback.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "flirt.newdefault.20080811.sch",
        "curses_flag": curses_flag,
        "scrollback_flag": scrollback_flag,
    }
    if term_option is not None:
        params["term_option"] = term_option
    return params


def flirt_newdefault_20080811_sch_cargs(
    params: FlirtNewdefault20080811SchParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("flirt.newdefault.20080811.sch")
    if params.get("term_option") is not None:
        cargs.extend([
            "-T",
            params.get("term_option")
        ])
    if params.get("curses_flag"):
        cargs.append("-V")
    if params.get("scrollback_flag"):
        cargs.append("-x")
    return cargs


def flirt_newdefault_20080811_sch_outputs(
    params: FlirtNewdefault20080811SchParameters,
    execution: Execution,
) -> FlirtNewdefault20080811SchOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FlirtNewdefault20080811SchOutputs(
        root=execution.output_file("."),
    )
    return ret


def flirt_newdefault_20080811_sch_execute(
    params: FlirtNewdefault20080811SchParameters,
    execution: Execution,
) -> FlirtNewdefault20080811SchOutputs:
    """
    FLIRT (FMRIB's Linear Image Registration Tool) new default configuration script.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FlirtNewdefault20080811SchOutputs`).
    """
    params = execution.params(params)
    cargs = flirt_newdefault_20080811_sch_cargs(params, execution)
    ret = flirt_newdefault_20080811_sch_outputs(params, execution)
    execution.run(cargs)
    return ret


def flirt_newdefault_20080811_sch(
    term_option: str | None = None,
    curses_flag: bool = False,
    scrollback_flag: bool = False,
    runner: Runner | None = None,
) -> FlirtNewdefault20080811SchOutputs:
    """
    FLIRT (FMRIB's Linear Image Registration Tool) new default configuration script.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        term_option: Use this terminal type instead of $TERM.
        curses_flag: Print curses-version.
        scrollback_flag: Do not try to clear scrollback.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FlirtNewdefault20080811SchOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FLIRT_NEWDEFAULT_20080811_SCH_METADATA)
    params = flirt_newdefault_20080811_sch_params(
        term_option=term_option,
        curses_flag=curses_flag,
        scrollback_flag=scrollback_flag,
    )
    return flirt_newdefault_20080811_sch_execute(params, execution)


__all__ = [
    "FLIRT_NEWDEFAULT_20080811_SCH_METADATA",
    "FlirtNewdefault20080811SchOutputs",
    "FlirtNewdefault20080811SchParameters",
    "flirt_newdefault_20080811_sch",
    "flirt_newdefault_20080811_sch_params",
]
