# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MORPH_SUBJECT_METADATA = Metadata(
    id="685f97530d830d12a67cb8468c38864b69d1e65c.boutiques",
    name="morph_subject",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


MorphSubjectParameters = typing.TypedDict('MorphSubjectParameters', {
    "__STYX_TYPE__": typing.Literal["morph_subject"],
    "subjid": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "morph_subject": morph_subject_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class MorphSubjectOutputs(typing.NamedTuple):
    """
    Output object returned when calling `morph_subject(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def morph_subject_params(
    subjid: str,
) -> MorphSubjectParameters:
    """
    Build parameters.
    
    Args:
        subjid: Subject ID for processing.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "morph_subject",
        "subjid": subjid,
    }
    return params


def morph_subject_cargs(
    params: MorphSubjectParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("morph_subject")
    cargs.append(params.get("subjid"))
    return cargs


def morph_subject_outputs(
    params: MorphSubjectParameters,
    execution: Execution,
) -> MorphSubjectOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MorphSubjectOutputs(
        root=execution.output_file("."),
    )
    return ret


def morph_subject_execute(
    params: MorphSubjectParameters,
    execution: Execution,
) -> MorphSubjectOutputs:
    """
    A morphological processing tool for Freesurfer subjects. The specific operations
    and options are not documented in the available help text.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MorphSubjectOutputs`).
    """
    params = execution.params(params)
    cargs = morph_subject_cargs(params, execution)
    ret = morph_subject_outputs(params, execution)
    execution.run(cargs)
    return ret


def morph_subject(
    subjid: str,
    runner: Runner | None = None,
) -> MorphSubjectOutputs:
    """
    A morphological processing tool for Freesurfer subjects. The specific operations
    and options are not documented in the available help text.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subjid: Subject ID for processing.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MorphSubjectOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MORPH_SUBJECT_METADATA)
    params = morph_subject_params(
        subjid=subjid,
    )
    return morph_subject_execute(params, execution)


__all__ = [
    "MORPH_SUBJECT_METADATA",
    "MorphSubjectOutputs",
    "MorphSubjectParameters",
    "morph_subject",
    "morph_subject_params",
]
