# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MRI_SEGMENT_METADATA = Metadata(
    id="a0c20f56e2e971cbda93e4d526f4cfbf192d2549.boutiques",
    name="mri_segment",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


MriSegmentParameters = typing.TypedDict('MriSegmentParameters', {
    "__STYX_TYPE__": typing.Literal["mri_segment"],
    "in_vol": InputPathType,
    "out_vol": str,
    "no1d_remove": typing.NotRequired[float | None],
    "slope": typing.NotRequired[float | None],
    "pslope": typing.NotRequired[float | None],
    "nslope": typing.NotRequired[float | None],
    "debug_voxel": typing.NotRequired[list[float] | None],
    "auto": bool,
    "noauto": bool,
    "log": bool,
    "keep": bool,
    "gray_hi": typing.NotRequired[float | None],
    "wm_low": typing.NotRequired[float | None],
    "wm_low_factor": typing.NotRequired[float | None],
    "wm_hi": typing.NotRequired[float | None],
    "nseg": typing.NotRequired[float | None],
    "thicken": bool,
    "fillbg": bool,
    "fillv": bool,
    "blur_sigma": typing.NotRequired[float | None],
    "iterations": typing.NotRequired[float | None],
    "thin_strand_limit": typing.NotRequired[float | None],
    "verbose": bool,
    "threshold": typing.NotRequired[float | None],
    "extract_options": typing.NotRequired[InputPathType | None],
    "wsize": typing.NotRequired[float | None],
    "wsizemm": typing.NotRequired[float | None],
    "polvw_size": typing.NotRequired[float | None],
    "polv_len": typing.NotRequired[float | None],
    "datfile": typing.NotRequired[InputPathType | None],
    "segmentation": typing.NotRequired[str | None],
    "diagno": typing.NotRequired[float | None],
    "diag_write": bool,
    "diag_verbose": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "mri_segment": mri_segment_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "mri_segment": mri_segment_outputs,
    }.get(t)


class MriSegmentOutputs(typing.NamedTuple):
    """
    Output object returned when calling `mri_segment(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_volume: OutputPathType
    """Segmented white matter output volume"""
    log_file: OutputPathType
    """Log file from segmentation process"""


def mri_segment_params(
    in_vol: InputPathType,
    out_vol: str,
    no1d_remove: float | None = None,
    slope: float | None = None,
    pslope: float | None = 1.0,
    nslope: float | None = 1.0,
    debug_voxel: list[float] | None = None,
    auto: bool = False,
    noauto: bool = False,
    log: bool = False,
    keep: bool = False,
    gray_hi: float | None = 100.0,
    wm_low: float | None = 80.0,
    wm_low_factor: float | None = None,
    wm_hi: float | None = 125.0,
    nseg: float | None = 20,
    thicken: bool = False,
    fillbg: bool = False,
    fillv: bool = False,
    blur_sigma: float | None = 0.25,
    iterations: float | None = 1,
    thin_strand_limit: float | None = 4,
    verbose: bool = False,
    threshold: float | None = 0.8,
    extract_options: InputPathType | None = None,
    wsize: float | None = 11,
    wsizemm: float | None = None,
    polvw_size: float | None = 5,
    polv_len: float | None = 3,
    datfile: InputPathType | None = None,
    segmentation: str | None = None,
    diagno: float | None = None,
    diag_write: bool = False,
    diag_verbose: bool = False,
) -> MriSegmentParameters:
    """
    Build parameters.
    
    Args:
        in_vol: Input volume to be segmented.
        out_vol: Output volume after segmentation.
        no1d_remove: Don't run code that removes 1D strands from segmentation.
        slope: Set the curvature slope (both n and p).
        pslope: Set the curvature pslope (default=1.0).
        nslope: Set the curvature nslope (default=1.0).
        debug_voxel: Set voxel for debugging.
        auto: Automatically detect class statistics (default).
        noauto: Don't automatically detect class statistics.
        log: Log to ./segment.dat.
        keep: Keep wm edits, maintains all values of 1 and 255.
        gray_hi: Set the gray matter high limit (default=100.000).
        wm_low: Set the white matter low limit (default=80.000).
        wm_low_factor: wm_low = f*gray_mean + (1-f)*white_mean;.
        wm_hi: Set the white matter high limit (default=125.000).
        nseg: Thicken the n largest thin strands (default=20).
        thicken: Toggle thickening step (default=ON).
        fillbg: Toggle filling of the basal ganglia (default=OFF).
        fillv: Toggle filling of the ventricles (default=OFF).
        blur_sigma: Set blur sigma (default=0.25).
        iterations: Set # iterations of border classification (default=1).
        thin_strand_limit: Set limit to thin strands in mm (default=4).
        verbose: Verbose.
        threshold: Set % threshold (default=0.80).
        extract_options: Extract options from filename.
        wsize: Set wsize (default=11 voxels).
        wsizemm: Set wsize based on mm instead of voxels.
        polvw_size: Set wsize for plane of least variance (default=5).
        polv_len: Set length for plane of least variance (default=3).
        datfile: Set datfile (default is segment.dat).
        segmentation: Use segmentation to set thresholds.
        diagno: Set diagnostic number.
        diag_write: Set diagnostic write.
        diag_verbose: Set diagnostic verbose.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "mri_segment",
        "in_vol": in_vol,
        "out_vol": out_vol,
        "auto": auto,
        "noauto": noauto,
        "log": log,
        "keep": keep,
        "thicken": thicken,
        "fillbg": fillbg,
        "fillv": fillv,
        "verbose": verbose,
        "diag_write": diag_write,
        "diag_verbose": diag_verbose,
    }
    if no1d_remove is not None:
        params["no1d_remove"] = no1d_remove
    if slope is not None:
        params["slope"] = slope
    if pslope is not None:
        params["pslope"] = pslope
    if nslope is not None:
        params["nslope"] = nslope
    if debug_voxel is not None:
        params["debug_voxel"] = debug_voxel
    if gray_hi is not None:
        params["gray_hi"] = gray_hi
    if wm_low is not None:
        params["wm_low"] = wm_low
    if wm_low_factor is not None:
        params["wm_low_factor"] = wm_low_factor
    if wm_hi is not None:
        params["wm_hi"] = wm_hi
    if nseg is not None:
        params["nseg"] = nseg
    if blur_sigma is not None:
        params["blur_sigma"] = blur_sigma
    if iterations is not None:
        params["iterations"] = iterations
    if thin_strand_limit is not None:
        params["thin_strand_limit"] = thin_strand_limit
    if threshold is not None:
        params["threshold"] = threshold
    if extract_options is not None:
        params["extract_options"] = extract_options
    if wsize is not None:
        params["wsize"] = wsize
    if wsizemm is not None:
        params["wsizemm"] = wsizemm
    if polvw_size is not None:
        params["polvw_size"] = polvw_size
    if polv_len is not None:
        params["polv_len"] = polv_len
    if datfile is not None:
        params["datfile"] = datfile
    if segmentation is not None:
        params["segmentation"] = segmentation
    if diagno is not None:
        params["diagno"] = diagno
    return params


def mri_segment_cargs(
    params: MriSegmentParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("mri_segment")
    cargs.append(execution.input_file(params.get("in_vol")))
    cargs.append(params.get("out_vol"))
    if params.get("no1d_remove") is not None:
        cargs.extend([
            "-no1d_remove",
            str(params.get("no1d_remove"))
        ])
    if params.get("slope") is not None:
        cargs.extend([
            "-slope",
            str(params.get("slope"))
        ])
    if params.get("pslope") is not None:
        cargs.extend([
            "-pslope",
            str(params.get("pslope"))
        ])
    if params.get("nslope") is not None:
        cargs.extend([
            "-nslope",
            str(params.get("nslope"))
        ])
    if params.get("debug_voxel") is not None:
        cargs.extend([
            "-debug_voxel",
            *map(str, params.get("debug_voxel"))
        ])
    if params.get("auto"):
        cargs.append("-auto")
    if params.get("noauto"):
        cargs.append("-noauto")
    if params.get("log"):
        cargs.append("-log")
    if params.get("keep"):
        cargs.append("-keep")
    if params.get("gray_hi") is not None:
        cargs.extend([
            "-ghi",
            str(params.get("gray_hi"))
        ])
    if params.get("wm_low") is not None:
        cargs.extend([
            "-wlo",
            str(params.get("wm_low"))
        ])
    if params.get("wm_low_factor") is not None:
        cargs.extend([
            "-wm_low_factor",
            str(params.get("wm_low_factor"))
        ])
    if params.get("wm_hi") is not None:
        cargs.extend([
            "-whi",
            str(params.get("wm_hi"))
        ])
    if params.get("nseg") is not None:
        cargs.extend([
            "-nseg",
            str(params.get("nseg"))
        ])
    if params.get("thicken"):
        cargs.append("-thicken")
    if params.get("fillbg"):
        cargs.append("-fillbg")
    if params.get("fillv"):
        cargs.append("-fillv")
    if params.get("blur_sigma") is not None:
        cargs.extend([
            "-b",
            str(params.get("blur_sigma"))
        ])
    if params.get("iterations") is not None:
        cargs.extend([
            "-n",
            str(params.get("iterations"))
        ])
    if params.get("thin_strand_limit") is not None:
        cargs.extend([
            "-t",
            str(params.get("thin_strand_limit"))
        ])
    if params.get("verbose"):
        cargs.append("-v")
    if params.get("threshold") is not None:
        cargs.extend([
            "-p",
            str(params.get("threshold"))
        ])
    if params.get("extract_options") is not None:
        cargs.extend([
            "-x",
            execution.input_file(params.get("extract_options"))
        ])
    if params.get("wsize") is not None:
        cargs.extend([
            "-w",
            str(params.get("wsize"))
        ])
    if params.get("wsizemm") is not None:
        cargs.extend([
            "-wsizemm",
            str(params.get("wsizemm"))
        ])
    if params.get("polvw_size") is not None:
        cargs.extend([
            "-polvwsize",
            str(params.get("polvw_size"))
        ])
    if params.get("polv_len") is not None:
        cargs.extend([
            "-polvlen",
            str(params.get("polv_len"))
        ])
    if params.get("datfile") is not None:
        cargs.extend([
            "-dat",
            execution.input_file(params.get("datfile"))
        ])
    if params.get("segmentation") is not None:
        cargs.extend([
            "-seg",
            params.get("segmentation")
        ])
    if params.get("diagno") is not None:
        cargs.extend([
            "-diagno",
            str(params.get("diagno"))
        ])
    if params.get("diag_write"):
        cargs.append("-diag-write")
    if params.get("diag_verbose"):
        cargs.append("-diag-verbose")
    return cargs


def mri_segment_outputs(
    params: MriSegmentParameters,
    execution: Execution,
) -> MriSegmentOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MriSegmentOutputs(
        root=execution.output_file("."),
        output_volume=execution.output_file(params.get("out_vol")),
        log_file=execution.output_file("./segment.dat"),
    )
    return ret


def mri_segment_execute(
    params: MriSegmentParameters,
    execution: Execution,
) -> MriSegmentOutputs:
    """
    Segments white matter from the input volume.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MriSegmentOutputs`).
    """
    params = execution.params(params)
    cargs = mri_segment_cargs(params, execution)
    ret = mri_segment_outputs(params, execution)
    execution.run(cargs)
    return ret


def mri_segment(
    in_vol: InputPathType,
    out_vol: str,
    no1d_remove: float | None = None,
    slope: float | None = None,
    pslope: float | None = 1.0,
    nslope: float | None = 1.0,
    debug_voxel: list[float] | None = None,
    auto: bool = False,
    noauto: bool = False,
    log: bool = False,
    keep: bool = False,
    gray_hi: float | None = 100.0,
    wm_low: float | None = 80.0,
    wm_low_factor: float | None = None,
    wm_hi: float | None = 125.0,
    nseg: float | None = 20,
    thicken: bool = False,
    fillbg: bool = False,
    fillv: bool = False,
    blur_sigma: float | None = 0.25,
    iterations: float | None = 1,
    thin_strand_limit: float | None = 4,
    verbose: bool = False,
    threshold: float | None = 0.8,
    extract_options: InputPathType | None = None,
    wsize: float | None = 11,
    wsizemm: float | None = None,
    polvw_size: float | None = 5,
    polv_len: float | None = 3,
    datfile: InputPathType | None = None,
    segmentation: str | None = None,
    diagno: float | None = None,
    diag_write: bool = False,
    diag_verbose: bool = False,
    runner: Runner | None = None,
) -> MriSegmentOutputs:
    """
    Segments white matter from the input volume.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        in_vol: Input volume to be segmented.
        out_vol: Output volume after segmentation.
        no1d_remove: Don't run code that removes 1D strands from segmentation.
        slope: Set the curvature slope (both n and p).
        pslope: Set the curvature pslope (default=1.0).
        nslope: Set the curvature nslope (default=1.0).
        debug_voxel: Set voxel for debugging.
        auto: Automatically detect class statistics (default).
        noauto: Don't automatically detect class statistics.
        log: Log to ./segment.dat.
        keep: Keep wm edits, maintains all values of 1 and 255.
        gray_hi: Set the gray matter high limit (default=100.000).
        wm_low: Set the white matter low limit (default=80.000).
        wm_low_factor: wm_low = f*gray_mean + (1-f)*white_mean;.
        wm_hi: Set the white matter high limit (default=125.000).
        nseg: Thicken the n largest thin strands (default=20).
        thicken: Toggle thickening step (default=ON).
        fillbg: Toggle filling of the basal ganglia (default=OFF).
        fillv: Toggle filling of the ventricles (default=OFF).
        blur_sigma: Set blur sigma (default=0.25).
        iterations: Set # iterations of border classification (default=1).
        thin_strand_limit: Set limit to thin strands in mm (default=4).
        verbose: Verbose.
        threshold: Set % threshold (default=0.80).
        extract_options: Extract options from filename.
        wsize: Set wsize (default=11 voxels).
        wsizemm: Set wsize based on mm instead of voxels.
        polvw_size: Set wsize for plane of least variance (default=5).
        polv_len: Set length for plane of least variance (default=3).
        datfile: Set datfile (default is segment.dat).
        segmentation: Use segmentation to set thresholds.
        diagno: Set diagnostic number.
        diag_write: Set diagnostic write.
        diag_verbose: Set diagnostic verbose.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MriSegmentOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MRI_SEGMENT_METADATA)
    params = mri_segment_params(
        in_vol=in_vol,
        out_vol=out_vol,
        no1d_remove=no1d_remove,
        slope=slope,
        pslope=pslope,
        nslope=nslope,
        debug_voxel=debug_voxel,
        auto=auto,
        noauto=noauto,
        log=log,
        keep=keep,
        gray_hi=gray_hi,
        wm_low=wm_low,
        wm_low_factor=wm_low_factor,
        wm_hi=wm_hi,
        nseg=nseg,
        thicken=thicken,
        fillbg=fillbg,
        fillv=fillv,
        blur_sigma=blur_sigma,
        iterations=iterations,
        thin_strand_limit=thin_strand_limit,
        verbose=verbose,
        threshold=threshold,
        extract_options=extract_options,
        wsize=wsize,
        wsizemm=wsizemm,
        polvw_size=polvw_size,
        polv_len=polv_len,
        datfile=datfile,
        segmentation=segmentation,
        diagno=diagno,
        diag_write=diag_write,
        diag_verbose=diag_verbose,
    )
    return mri_segment_execute(params, execution)


__all__ = [
    "MRI_SEGMENT_METADATA",
    "MriSegmentOutputs",
    "MriSegmentParameters",
    "mri_segment",
    "mri_segment_params",
]
