# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

REINFLATE_SUBJECT_RH_METADATA = Metadata(
    id="9cd92db80be80b0a27f77251253c9b44f8012411.boutiques",
    name="reinflate_subject-rh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


ReinflateSubjectRhParameters = typing.TypedDict('ReinflateSubjectRhParameters', {
    "__STYX_TYPE__": typing.Literal["reinflate_subject-rh"],
    "subject_dir": str,
    "additional_options": typing.NotRequired[str | None],
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "reinflate_subject-rh": reinflate_subject_rh_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class ReinflateSubjectRhOutputs(typing.NamedTuple):
    """
    Output object returned when calling `reinflate_subject_rh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def reinflate_subject_rh_params(
    subject_dir: str,
    additional_options: str | None = None,
) -> ReinflateSubjectRhParameters:
    """
    Build parameters.
    
    Args:
        subject_dir: Directory of the subject within FreeSurfer environment.
        additional_options: Additional options for the reinflate_subject-rh\
            command.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "reinflate_subject-rh",
        "subject_dir": subject_dir,
    }
    if additional_options is not None:
        params["additional_options"] = additional_options
    return params


def reinflate_subject_rh_cargs(
    params: ReinflateSubjectRhParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("reinflate_subject-rh")
    cargs.extend([
        "-rh",
        params.get("subject_dir")
    ])
    if params.get("additional_options") is not None:
        cargs.append(params.get("additional_options"))
    return cargs


def reinflate_subject_rh_outputs(
    params: ReinflateSubjectRhParameters,
    execution: Execution,
) -> ReinflateSubjectRhOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = ReinflateSubjectRhOutputs(
        root=execution.output_file("."),
    )
    return ret


def reinflate_subject_rh_execute(
    params: ReinflateSubjectRhParameters,
    execution: Execution,
) -> ReinflateSubjectRhOutputs:
    """
    A tool for reinflating the cortical surfaces for a given subject in FreeSurfer,
    specifically for the right hemisphere.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `ReinflateSubjectRhOutputs`).
    """
    params = execution.params(params)
    cargs = reinflate_subject_rh_cargs(params, execution)
    ret = reinflate_subject_rh_outputs(params, execution)
    execution.run(cargs)
    return ret


def reinflate_subject_rh(
    subject_dir: str,
    additional_options: str | None = None,
    runner: Runner | None = None,
) -> ReinflateSubjectRhOutputs:
    """
    A tool for reinflating the cortical surfaces for a given subject in FreeSurfer,
    specifically for the right hemisphere.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subject_dir: Directory of the subject within FreeSurfer environment.
        additional_options: Additional options for the reinflate_subject-rh\
            command.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `ReinflateSubjectRhOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(REINFLATE_SUBJECT_RH_METADATA)
    params = reinflate_subject_rh_params(
        subject_dir=subject_dir,
        additional_options=additional_options,
    )
    return reinflate_subject_rh_execute(params, execution)


__all__ = [
    "REINFLATE_SUBJECT_RH_METADATA",
    "ReinflateSubjectRhOutputs",
    "ReinflateSubjectRhParameters",
    "reinflate_subject_rh",
    "reinflate_subject_rh_params",
]
